#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int N, Q;
    cin >> N >> Q;

    vector<pair<int, int>> pakovanja;

    for (int i = 0; i < N; ++i) {
        int d, p;
        cin >> d >> p;
        pakovanja.push_back({d, p});
    }

    vector<int> pitanja(Q);
    for (int i = 0; i < Q; ++i) {
        cin >> pitanja[i];
    }

    for (int i = 0; i < Q; ++i) {
        int k = pitanja[i];
        long long ukupno = 0;

        for (const auto& p : pakovanja) {
            int dan = p.first;
            int broj_pakovanja = p.second;


            if (dan <= k) {
                ukupno += min(broj_pakovanja, k - dan + 1);
            }
        }

        cout << ukupno << endl;
    }

    return 0;
}